/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 * 
 * Many parts of this code are based on the following extensions 
 * http://webdeveloper.mozdev.org
 * http://expasybar.mozdev.org
 * http://msdbar.mozdev.org
 * 
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Jawahar Swaminathan <jawahar@ebi.ac.uk>
 */


/*
 * doXxxx function's
*/

function biobar_InitPrefs() {
	var biobarprefs=get_biobarPrefService();
	if (!biobarprefs.prefHasUserValue("sequences")) {
		biobarprefs.setBoolPref("sequences",true);
	}
	if (!biobarprefs.prefHasUserValue("structures")) {
		biobarprefs.setBoolPref("structures",true);
	}
	if (!biobarprefs.prefHasUserValue("function")) {
		biobarprefs.setBoolPref("function",true);
	}
	if (!biobarprefs.prefHasUserValue("plant")) {
		biobarprefs.setBoolPref("plant",true);
	}
	if (!biobarprefs.prefHasUserValue("animal")) {
		biobarprefs.setBoolPref("animal",true);
	}
	if (!biobarprefs.prefHasUserValue("fungus")) {
		biobarprefs.setBoolPref("fungus",true);
	}
	if (!biobarprefs.prefHasUserValue("EBI")) {
		biobarprefs.setBoolPref("EBI",true);
	}
	if (!biobarprefs.prefHasUserValue("NCBI")) {
		biobarprefs.setBoolPref("NCBI",true);
	}
	if (!biobarprefs.prefHasUserValue("DDBJ")) {
		biobarprefs.setBoolPref("DDBJ",true);
	}
	if (!biobarprefs.prefHasUserValue("tool.count")) {
		biobarprefs.setIntPref("tool.count",0);
	}
	if (!biobarprefs.prefHasUserValue("default.database")) {
		biobarprefs.setCharPref("default.database","Choose Database");
	}
	if(!biobarprefs.prefHasUserValue("tab.preference")) {
		biobarprefs.setCharPref("tab.preference","NewTab");
	}
	if(!biobarprefs.prefHasUserValue("group.preference")) {
		biobarprefs.setBoolPref("group.preference",false);
	} 
	biobar_checkPrefs();
	return;
}

function get_biobarPrefService()
{
	var Myprefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("biobar.");
	return(Myprefs);
}

function biobar_checkPrefs()
{

	const biobarprefs=get_biobarPrefService();
	if (biobarprefs.getBoolPref("group.preference") == true) {
		doBiobarGroupInit(); }
	else {
		biobar_firstStep();
	}
}

//alert("A older version of the BiobarSearch.xml file exists in your profile.\ Will not use the latest file in extension directory. \ Please remove BiobarSearch.xml in profile or merge changes");


function biobar_firstStep()
{
	var biobar_XMLFile;
	var localXMLFile="BiobarSearch.xml";
	var file=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD",Components.interfaces.nsIFile);
	file.append(localXMLFile);
	if(!file.exists()) {
		biobar_XMLFile="chrome://biobar/content/BiobarSearch.xml";
	} else {
		var uri = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newFileURI(file);
		biobar_XMLFile = uri.spec;
	}
	biobar_load_XMLFile(biobar_XMLFile);
	biobar_makeMainMenu();
	biobar_DisplayCheck();
}

var biobar_xmlFile;
function biobar_load_XMLFile(file) {
	biobar_xmlFile= document.implementation.createDocument("","doc", null);
	biobar_xmlFile.async = false;
	biobar_xmlFile.load(file);
	return(biobar_xmlFile);
}

function biobar_makeDefault() {
	var d = document;
	var popup = d.getElementById('biobar_default.popup');
	alert(popup);
	var database = d.getElementById('biobar.default.database');
	try {	database.removeChild(popup);
	} catch(e) { alert(e); }
	alert("I am here");
	var p = d.createElement('menupopup');
	p.setAttribute('id', "biobar_default.popup");
	p.setAttribute('crop', "right");
	try {	var biobar_Menus = biobar_xmlFile.getElementsByTagName("Database");
	} catch(e) { alert(e); }
	for (var i=0; i<biobar_Menus.length; i++) {
		var tmp = biobar_Menus[i].getAttribute("type");
		alert(tmp);
		var tmp_items = d.createElement('menuitem');
		tmp_items.setAttribute('label', tmp);
		tmp_items.setAttribute('value', tmp);
		p.appendChild(tmp_items);
	}
	database.appendChild(p);
}
function biobar_makeMainMenu() {

	var d = document;
	var popup       =  d.getElementById('server1.popup');
	var database    =  d.getElementById('server1');
	var value       = d.getElementById('server1').value;
	database.removeChild(popup);
	var p = d.createElement('menupopup');
	p.setAttribute('id', "server1.popup");
	p.setAttribute('crop', "right");
	var newElement = d.createElement('menuitem');
	newElement.setAttribute('oncommand', 'biobar_default()');
	newElement.setAttribute('label', 'Default Database');
	newElement.setAttribute('tooltiptext', 'Go back to default database (if set)');
	p.appendChild(newElement);
	var tmp = new Array('EBI', 'NCBI', 'DDBJ');
	for (var t=0; t<tmp.length; t++) {
		newElement = d.createElement('menuitem');
		newElement.setAttribute('label', tmp[t]);
		newElement.setAttribute('value', tmp[t]);
		newElement.setAttribute('id', tmp[t]);
		newElement.setAttribute('oncommand', 'biobar_SearchMenu()');
		p.appendChild(newElement);
	}
	var biobar_Menus = biobar_xmlFile.getElementsByTagName("Group");
	for (var i=0; i<biobar_Menus.length; i++) {
		var biobar_Menu = biobar_Menus[i].getAttribute("type");
		var tmp_menu = d.createElement('menu');
		tmp_menu.setAttribute('label', biobar_Menu);
		tmp_menu.setAttribute('id', biobar_Menu);
		tmp_menu.setAttribute('value', biobar_Menu);
		tmp_menu.setAttribute('class', 'menuitem-non-iconic');
		tmp_menu.setAttribute('oncommand', 'doCMD(event.target)');
		var tmp_tmp = d.createElement('menupopup');
		tmp_menu.appendChild(tmp_tmp);
		var biobar_Menuitems = biobar_Menus[i].getElementsByTagName("Database");
		for (var m=0; m<biobar_Menuitems.length; m++) {
			var biobar_Name = biobar_Menuitems[m].getAttribute("type");
			var biobar_names = d.createElement('menuitem');
			biobar_names.setAttribute('label', biobar_Name);
			biobar_names.setAttribute('value', biobar_Name);
			tmp_tmp.appendChild(biobar_names);
		}
		p.appendChild(tmp_menu);

	}
	database.appendChild(p);


}
function doCheck() {
	var QueryPDB = document.getElementById("queryPDB").value;
	var QueryBox = document.getElementById("queryTextbox").value;
	var jjj = document.getElementById('server1').value;
	const biobarprefs = get_biobarPrefService();
	if(biobarprefs.getBoolPref("group.preference") == true) {
		doBiobargroupCheck() }
	else {
		if (QueryBox !== "" && QueryPDB == "") {

			if (jjj=="NCBI") {
				doNCBI();
			} else if (jjj == "EBI") {
				doEBI();
			} else if (jjj=="ASD") {
				doASD();
			} else if (jjj=="DDBJ") {
				doDDBJ();
			} else if (jjj=="aMAZE") {
				doaMAZE();
			} else if (jjj=="BioCyc") {
				doBioCyc();
			} else {
				do_biobarSearch(jjj);
			}
		}

		else if (QueryPDB !== "" && QueryBox == "") {
			doPDB();
		}
		else if (QueryPDB !== "" && QueryBox !== "") {
			alert('Both search boxes are filled in. Please clear one');
		}
		else if (QueryPDB == "" && QueryBox == "") {
			alert('You need at least one Search Term');
		}
	}
}

function do_biobarSearch(jjj) {
	try {
		var searchstring = document.getElementById('queryTextbox').value;
		var search_for = document.getElementById('database').value;
		biobar_parseXML(search_for, searchstring, jjj);
	} catch(e) { alert(e)
	}

}

function biobar_parseXML(search_for, searchstring, jjj){
	try {
	} catch(e) { alert(e)}
	var GroupDB = biobar_xmlFile.getElementsByTagName("Database");
	for (var q=0; q<GroupDB.length; q++) {
		if (GroupDB[q].getAttribute("type") == jjj)
		{
			var bbdatabase = GroupDB[q].getElementsByTagName("Menuitem");
			for(var i=0; i<bbdatabase.length; i++) {
				if (bbdatabase[i].getAttribute("name") == search_for)
				{
					var urlT = bbdatabase[i].getAttribute("url");
					if(GroupDB[q].getAttribute("type") == "RCSB") {
						var SearchTerm=(getserverRCSB()+urlT+searchstring);
					} else if (GroupDB[q].getAttribute("type") == "OCA") {
						var SearchTerm=(getserverOCA()+urlT+searchstring);
					} else if (GroupDB[q].getAttribute("type") == "Flybase") {
						var SearchTerm=(getserverFlybase()+urlT+searchstring);
					} else if (GroupDB[q].getAttribute("type") == "ExPasy") {
						var SearchTerm=(getserverExpasy()+urlT+searchstring);
					} else {
						var SearchTerm=(urlT+searchstring);
					}
					doBiobarURL(SearchTerm);

				}

			}

		}
	}
	return;

}

function biobar_SearchMenu()
{
	document.getElementById('biocyc').hidden = true;
	document.getElementById('amaze').hidden = true;
	document.getElementById('asd').hidden = true;
	document.getElementById('searchPDB').hidden = true;
	document.getElementById('queryPDB').hidden= true;

	var d           = document;
	var pdb         = d.getElementById('queryPDB').value;
	if (server =="MSD" || server =="RCSB" || server =="PDBJ" || server =="OCA") {
		document.getElementById('queryPDB').value= pdb;
	} else {
		document.getElementById('queryPDB').value= "";
	}
	var popup       =  d.getElementById('biobar.popup');
	var database    =  d.getElementById('database');
	var value       = d.getElementById('database').value;
	var server      =  d.getElementById('server1').value;
	database.removeChild(popup);
	var p = d.createElement('menupopup');
	p.setAttribute('id', "biobar.popup");
	p.setAttribute('crop', "right");

	if (server =="MSD" || server=="RCSB" || server=="PDBJ" || server=="PDBsum" || server=="OCA") {
		d.getElementById('queryPDB').hidden=false;
		d.getElementById('searchPDB').hidden = false;
	} else if (server == "ASD") {
		document.getElementById('asd').hidden = false;
	} else if (server =="BioCyc") {
		d.getElementById('biocyc').hidden = false;
		biobar_getBiocyc();
	} else if (server =="aMAZE") {
		d.getElementById('amaze').hidden=false;
	}

	var menuitems = biobar_xmlFile.getElementsByTagName("Database");
	for (var g=0; g<menuitems.length; g++)
	{
		if (menuitems[g].getAttribute("type") == server)
		{
			var newMenuitems = menuitems[g].getElementsByTagName("Menuitem");
			for (var f=0; f<newMenuitems.length; f++)
			{
				var tmp = newMenuitems[f].getAttribute("name");
				var newElement;
				newElement = d.createElement('menuitem');
				newElement.setAttribute('value', tmp);
				newElement.setAttribute('label', tmp);
				p.appendChild(newElement);
			}
		}
	}
	database.appendChild(p);
	database.selectedItem = null;
	database.value = value;
	if (!database.selectedItem) {
		database.value = newMenuitems[0].getAttribute("name");
	}
	return true;
}

function biobar_default() {
	var biobarprefs=get_biobarPrefService();
	var bbdefault = biobarprefs.getCharPref("default.database");
	var jjj = document.getElementById('server1').value;
	if(biobarprefs.getBoolPref("group.preference") == true) {
		doBiobarGroupInit(); }
	else {
		if (bbdefault == "Choose Database" || bbdefault == "") {
			biobarprefs.setCharPref("default.database", "MSD");
			document.getElementById('server1').value = "MSD";
			biobar_SearchMenu();//gMenu();
		} else {
			document.getElementById('server1').value = bbdefault;
			if (document.getElementById('server1').value == "BioCyc") {
				biobar_getBiocyc();
				//				gMenu();
			} else {
				biobar_SearchMenu();
			}

		}
	}
}


var seQn;
var Strc;
var Func;
var Plnt;
var Anml;
var Fngs;
var Ebi;
var NCbi;
var DDbj;
function biobar_DisplayCheck() {
		const biobarprefs=get_biobarPrefService();
		var  Ebi  = biobarprefs.getBoolPref("EBI");
		var  NCbi = biobarprefs.getBoolPref("NCBI");
		var  DDbj = biobarprefs.getBoolPref("DDBJ");
		var  seQn = biobarprefs.getBoolPref("sequences");
		var  Strc = biobarprefs.getBoolPref("structures");
		var  Func = biobarprefs.getBoolPref("function");
		var  Plnt = biobarprefs.getBoolPref("plant");
		var  Anml = biobarprefs.getBoolPref("animal");
		var  Fngs = biobarprefs.getBoolPref("fungus");
		if (!seQn) {
			document.getElementById('Sequences').hidden = true;
		} else {
			document.getElementById('Sequences').hidden = false;
		}

		if (!Strc) {
			document.getElementById('Structures').hidden = true;
		} else {
			document.getElementById('Structures').hidden = false;
		}

		if(!Func) {
			document.getElementById('Function').hidden = true;
		} else {
			document.getElementById('Function').hidden = false;
		}

		if(!Plnt) {
			document.getElementById('Plant').hidden = true;
		} else {
			document.getElementById('Plant').hidden = false;
		}

		if(!Anml) {
			document.getElementById('Animal').hidden = true;
		} else {
			document.getElementById('Animal').hidden = false;
		}
		if(!Fngs) {
			document.getElementById('Fungal').hidden = true;
		} else {
			document.getElementById('Fungal').hidden = false;
		}

		if(!Ebi) {
			document.getElementById('EBI').hidden = true;
		} else {
			document.getElementById('EBI').hidden = false;
		}

		if(!NCbi) {
			document.getElementById('NCBI').hidden = true;
		} else {
			document.getElementById('NCBI').hidden = false;
		}

		if(!DDbj) {
			document.getElementById('DDBJ').hidden = true;

		} else {
			document.getElementById('DDBJ').hidden = false;
		}

}
function biobar_updateBiocyc() {
	var biobarprefs=get_biobarPrefService();
	if (!biobarprefs.prefHasUserValue("lastrun.date")) {
		var date = biobar_getDate();
		biobarprefs.setIntPref("lastrun.date", date)
	} else {
		var lastrundate = biobarprefs.getIntPref("lastrun.date");
	}
	var now = biobar_getDate();
	var dateSince = now - lastrundate;
	if (dateSince>=10) {
		var xmlfile="bioCyc.xml";
		var address = "http://biocyc.org/databases.xml";
		biobar_compareVersions(xmlfile, address);
	}
}

function biobar_getBiocyc() {
	var bioCyc_XMLFile;
	bioCyc_XMLFile="chrome://biobar/content/bioCyc.xml";
	bioCyc_xmlFile= document.implementation.createDocument("","doc", null);
	bioCyc_xmlFile.async = false;
	bioCyc_xmlFile.load(bioCyc_XMLFile);
//	biobar_load_XMLFile(bioCyc_XMLFile);	
	var d           = document;
	var database    = d.getElementById('biocyc');
	var value =       d.getElementById('biocyc').value;
	var popup       =  d.getElementById('biocyc.popup');
	// Remove Old popup and create a new one to populate

	database.removeChild(popup);
	var p = d.createElement('menupopup');
	p.setAttribute('id', "biocyc.popup");
	p.setAttribute('crop', "right");

	// Parse the XML file
	var bbdatabase = bioCyc_xmlFile.getElementsByTagName("database");
	for(var i=0; i<bbdatabase.length; i++)
	{
		bbid = bbdatabase[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
		bbdescription = bbdatabase[i].getElementsByTagName("description")[0].childNodes[0].nodeValue;
		var menuItem = d.createElement("menuitem");
		menuItem.setAttribute('label', bbdescription.substring(0,30));
		menuItem.setAttribute('value', bbid);
		menuItem.setAttribute('tooltiptext', bbdescription);
		p.appendChild(menuItem);
	}
	var j1 = bbdatabase[0].getElementsByTagName("name")[0].childNodes[0].nodeValue;
	database.appendChild(p);
	database.selectedItem = null;
	database.value = value;
	if (!database.selectedItem) {
		database.value = bbdatabase[0].getElementsByTagName("description")[0].childNodes[0].nodeValue;
	}
	return true;
}



//Older version, does not work with getting XML file from network - Jawahar 02Dec2005
	// function biobar_getBiocyc()
// {
	// var xmlfile = "extensions/{3e559c3c-4aad-4168-bd47-e1056298df8e}/defaults/preferences/bioCyc.xml";
	// var address = "http://biocyc.org/databases.xml";
	// var bbid;
	// var bbdescription;
	// var path;
	// var uri;
	// var ioService;
	// var d           = document;
	// var database    = d.getElementById('biocyc');
	// var value =       d.getElementById('biocyc').value;
	// var popup       =  d.getElementById('biocyc.popup');
	// // Remove Old popup and create a new one to populate
// 
	// database.removeChild(popup);
	// var p = d.createElement('menupopup');
	// p.setAttribute('id', "biocyc.popup");
	// p.setAttribute('crop', "right");
// 
	// //Create document object
	// var xmlDoc = document.implementation.createDocument("","doc",null);
	// xmlDoc.async=false;
	// //Get the File URI
	// var fileobject = biobar_getFileObject(address,path,xmlfile);
	// xmlDoc.load(fileobject.spec);
	// // Parse the XML file
	// var bbdatabase = xmlDoc.getElementsByTagName("database");
	// for(var i=0; i<bbdatabase.length; i++)
	// {
		// bbid = bbdatabase[i].getElementsByTagName("id")[0].childNodes[0].nodeValue;
		// bbdescription = bbdatabase[i].getElementsByTagName("description")[0].childNodes[0].nodeValue;
		// var menuItem = d.createElement("menuitem");
		// menuItem.setAttribute('label', bbdescription.substring(0,30));
		// menuItem.setAttribute('value', bbid);
		// menuItem.setAttribute('tooltiptext', bbdescription);
		// p.appendChild(menuItem);
	// }
	// var j1 = bbdatabase[0].getElementsByTagName("name")[0].childNodes[0].nodeValue;
	// database.appendChild(p);
	// database.selectedItem = null;
	// database.value = value;
	// if (!database.selectedItem) {
		// database.value = bbdatabase[0].getElementsByTagName("description")[0].childNodes[0].nodeValue;
	// }
	// return true;
// }

function getserverOCA() {
	var pref = get_biobarPrefService();
	var t;
	var r;
	try {
		t = pref.getCharPref("OCA.name.server");
		r = "http://" + pref.getCharPref("OCA.name.server");
		return(r);
	}catch(e){
		pref.setCharPref("OCA.name.server", "oca.ebi.ac.uk/oca-bin/ocaids");
		alert("Please customise your OCA mirror from the Options Menu.\n Setting default value to OCA@EBI.");
		r = "http://" + pref.getCharPref("OCA.name.server");
		return(r);
	}
}

function getserverRCSB() {
	var pref = get_biobarPrefService();
	var u;
	var s;
	try{
		s = pref.getCharPref("RCSB.name.server");
		u = "http://" + pref.getCharPref("RCSB.name.server")+"/";
		return(u);
	}catch (e){
		pref.setCharPref("RCSB.name.server", "www.rcsb.org/pdb/");
		alert("Please customise your RCSB mirror from the Options Menu.\n Setting default value to RCSB Home.");
		u = "http://" + pref.getCharPref("RCSB.name.server")+"/";
		return(u);
	}
}

function getserverExpasy() {
	var pref = get_biobarPrefService();
	var u;
	var s;
	try{
		s = pref.getCharPref("Expasy.name.server");
		u = "http://" + pref.getCharPref("Expasy.name.server")+"/";
		return(u);
	}catch (e){
		pref.setCharPref("Expasy.name.server", "www.expasy.org/");
		alert("Please customise your Expasy mirror from the Options Menu.\n Setting default value to Expasy Home.");
		u = "http://" + pref.getCharPref("Expasy.name.server")+"/";
		return(u);
	}
}

function getserverFlybase() {
	var pref = get_biobarPrefService();
	var u;
	var s;
	try{
		s = pref.getCharPref("Flybase.name.server");
		u = "http://" + pref.getCharPref("Flybase.name.server")+"/";
		return(u);
	}catch (e){
		pref.setCharPref("Flybase.name.server", "flybase.bio.indiana.edu/");
		alert("Please customise your Flybase mirror from the Options Menu.\n Setting default value to Flybase Home.");
		u = "http://" + pref.getCharPref("Flybase.name.server")+"/";
		return(u);
	}
}

function biobar_options() {
	window.openDialog("chrome://biobar/content/options/options.xul", "biobar-options-dialog", "centerscreen,chrome,modal");
}

function doaMAZE() {
	var url = "";
	var parm_cmd = "";
	var parm_db = "";
	var search_for = document.getElementById('database').value;
	var species  = document.getElementById('amaze').value;

	switch(search_for) {

	case 'Genes':
		url="http://www.amaze.ulb.ac.be/lightbench/genes?";
		parm_cmd="expression_input=on&toolbar=biobar&organism="+species+"&name_regexp";
		parm_db="=";
		parm_term=document.getElementById('queryTextbox').value;
		break;
	case 'Polypeptides':
		url="http://www.amaze.ulb.ac.be/lightbench/polypeptides?";
		parm_cmd="expression_input=on&toolbar=biobar&organism="+species+"&name_regexp";
		parm_db="=";
		parm_term=document.getElementById('queryTextbox').value;
		break;

	case 'Compounds':
		url="http://www.amaze.ulb.ac.be/lightbench/compounds?";
		parm_cmd="toolbar=biobar&name_regexp";
		parm_db="=";
		parm_term=document.getElementById('queryTextbox').value;
		break;

	case 'Organisms':
		document.getElementById('biocyc').hidden = true;
		url="http://www.amaze.ulb.ac.be/lightbench/organisms/index_html?";
		parm_cmd="toolbar=biobar&name_regexp";
		parm_db="=";
		parm_term=document.getElementById('queryTextbox').value;
		break;

	case 'Processes':
		url="http://www.amaze.ulb.ac.be/lightbench/processes?";
		parm_cmd="expression_input=on&toolbar=biobar&organism="+species+"&name_regexp";
		parm_db="=";
		parm_term=document.getElementById('queryTextbox').value;
		break;

	}
	var QueryBox = document.getElementById("queryTextbox");
	msdAddTerm(QueryBox.value);
	var SearchTerm = url+parm_cmd+parm_db+parm_term;
	doBiobarURL(SearchTerm);
}

function doASD() {
	var url = "";
	var parm_cmd = "";
	var parm_term = "";
	var parm_db = "";
	var search_for = document.getElementById('database').value;
	var asddb = document.getElementById('asd').value;
	var asdsrch;
	switch (search_for) {
	case 'Any fields':
	case 'Gene Symbols':
	case 'Keywords/Gene Symbols':
	case 'Cross References':
		asdsrch = search_for.replace(/ /, "+");
		url="http://www.ebi.ac.uk/asd-srv/Index.cgi?method=GETDAT_S&product=SINGLE";
		parm_cmd ="&toolbar=biobar&databases="+asddb+"&field="+asdsrch+"&single_box_submit=Go&keywords";
		parm_db="=";
		parm_term=document.getElementById('queryTextbox').value;
		break;
	}
	var QueryBox = document.getElementById("queryTextbox");
	msdAddTerm(QueryBox.value);
	var SearchTerm = url+parm_cmd+parm_db+parm_term;
	doBiobarURL(SearchTerm);
}

function doBioCyc() {
	var url = "";
	var parm_cmd = "";
	var parm_term = "";
	var parm_db = "";
	var        search_for = document.getElementById('database').value;
	var        species  = document.getElementById('biocyc').value;

	switch(search_for) {
	case 'All':
		url="http://biocyc.org/"+species+"/substring-search?";
		parm_cmd ="type=NIL&toolbar=biobar&object";
		parm_db="=";
		parm_term= document.getElementById('queryTextbox').value;
		break;
	case 'Protein':
		url="http://biocyc.org/"+species+"/substring-search?";
		parm_cmd ="type=ENZYME&toolbar=biobar&object";
		parm_db="=";
		parm_term= document.getElementById('queryTextbox').value;
		break;
	case 'Pathway':
		url="http://biocyc.org/"+species+"/substring-search?";
		parm_cmd ="type=PATHWAY&toolbar=biobar&object";
		parm_db="=";
		parm_term= document.getElementById('queryTextbox').value;
		break;
	case 'Reaction':
		url="http://biocyc.org/"+species+"/substring-search?";
		parm_cmd ="type=REACTION&toolbar=biobar&object";
		parm_db="=";
		parm_term= document.getElementById('queryTextbox').value;
		break;
	case 'Compound':
		url="http://biocyc.org/"+species+"/substring-search?";
		parm_cmd ="type=COMPOUND&toolbar=biobar&object";
		parm_db="=";
		parm_term= document.getElementById('queryTextbox').value;
		break;
	case 'Gene':
		url="http://biocyc.org/"+species+"/substring-search?";
		parm_cmd ="type=GENE&toolbar=biobar&object";
		parm_db="=";
		parm_term= document.getElementById('queryTextbox').value;
		break;
	}
	var QueryBox = document.getElementById("queryTextbox");
	msdAddTerm(QueryBox.value);
	var SearchTerm = url+parm_cmd+parm_db+parm_term;
	doBiobarURL(SearchTerm);
}
function doDDBJ() {

	var url = "";
	var parm_cmd = "";
	var parm_term = "";
	var parm_db = "";
	var        search_for = document.getElementById('database').value;

	switch (search_for) {
	case 'All DDBJ' :
		url = "http://www.ddbj.nig.ac.jp/cgi-bin/namazu.cgi?";
		parm_cmd ="toolbar=biobar&lang=en&max=20&result=normal&sort=score&query";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'DNA' :
		url = "http://srs.ddbj.nig.ac.jp/cgi-bin/wgetz?";
		parm_cmd ="-newId+-view+SeqSimpleView+-e+[{ddbjrelease%20ddbjnew}-AllText";
		parm_db =":";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']";
		break;

	case 'Protein' :
		url = "http://srs.ddbj.nig.ac.jp/cgi-bin/wgetz?";
		parm_cmd ="-newId+-view+SeqSimpleView+-e+[{swissprot%20pir%20dadrelease%20dadnew%20pdb}-AllText";
		parm_db =":";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']";
		break;
	}
	var QueryBox = document.getElementById("queryTextbox");
	msdAddTerm(QueryBox.value);
	var SearchTerm = url+parm_cmd+parm_db+parm_term;
	doBiobarURL(SearchTerm);
}

function doEBI() {

	var url = "";
	var parm_cmd = "";
	var parm_term = "";
	var parm_db = "";
	var        search_for = document.getElementById('database').value;
	switch(search_for) {
		//http://srs.ebi.ac.uk/srsbin/cgi-bin/wgetz?-newId+[libs%3d{embl%20emblcon}-AllText:hydrolase*]+-view+EMBLSeqSimpleView+-page+qResult
	case 'Nucleotide' :
		url = "http://srs.ebi.ac.uk/cgi-bin/wgetz?";
		parm_cmd = "-newId+[{embl%20emblcon}-AllText:";
		parm_db  = "";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']+-view+EMBLSeqSimpleView+-page+qResult";
		break;
	case 'Protein' :
		url = "http://srs.ebi.ac.uk/cgi-bin/wgetz?";
		parm_cmd = "-newId+-view+SeqSimpleView+-e+[{UNIPROT%20UNIPARC}-AllText:";
		parm_db  = "";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']";
		break;
	case 'Structure':
		url = "http://srs.ebi.ac.uk/cgi-bin/wgetz?";
		parm_cmd = "-newId+[PDB-AllText:";
		parm_db  = "";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']+-page+qResult";
		break;
	case 'Signatures' :
		url = "http://srs.ebi.ac.uk/cgi-bin/wgetz?";
		parm_cmd = "-newId+[INTERPRO-AllText:";
		parm_db  = "";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']+-view+InterproTable+-page+qResult";
		break;
	case 'Literature' :
		url = "http://srs.ebi.ac.uk/srsbin/cgi-bin/wgetz?";
		parm_cmd = "-newId+[MEDLINE-AllText:";
		parm_db  = "";
		parm_term = "'"+document.getElementById('queryTextbox').value+"*']+-vn+3+-page+qResult+w";
		break;
	}
	var QueryBox = document.getElementById("queryTextbox");
	msdAddTerm(QueryBox.value);
	var SearchTerm = url+parm_cmd+parm_db+parm_term;
	doBiobarURL(SearchTerm);
}

function doNCBI() {
	var nlib;
	var biobarprefs = get_biobarPrefService();
	try {
		nlib= "holding="+biobarprefs.getCharPref("NCBI.holding");
	} catch (e) {
		dump ("\n" + e + "\n");
		nlib = "holding=";
	}
	var url = "";
	var parm_cmd = "";
	var parm_term = "";
	var parm_db = "";
	var        search_for = document.getElementById('database').value;
	switch (search_for) {
	case 'PubMed' :
	case 'OMIM' :
	case 'Nucleotide' :
	case 'Structure' :
	case 'Protein' :
	case 'Genome' :
	case 'MeSH' :
	case 'Taxonomy' :
	case 'SNP' :
	case 'Gene' :
	case 'HomoloGene' :
	case 'UniGene' :
	case 'CDD' :
	case 'UniSTS' :
	case 'PopSet' :
	case 'Journals' :
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?"+nlib;
		parm_cmd ="&db="+search_for+"&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'PubChem BioAssay':
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?"+nlib;
		parm_cmd ="&db=pcassay&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'PubChem Compound':
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?"+nlib;
		parm_cmd ="&db=pccompound&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'PubChem Substance':
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?"+nlib;
		parm_cmd ="&db=pcsubstance&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'Entrez':
		url = "http://www.ncbi.nlm.nih.gov/gquery/gquery.fcgi?"+nlib;
		parm_cmd ="&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'GEO Profiles' :
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?";
		parm_cmd ="db=geo&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'GEO Datasets' :
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?";
		parm_cmd ="db=gds&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case '3D Domains' :
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?";
		parm_cmd ="db=domains&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;
	case 'Cancer Chromosomes' :
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?";
		parm_cmd ="db=cancerchromosomes&cmd=search&term";
		parm_db ="=";
		parm_term = document.getElementById('queryTextbox').value;
		break;

	default :
		url = "http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?";
		parm_cmd = "textSearch";
		parm_db = "=";
		parm_term = document.getElementById('queryTextbox').value;
	}
	var QueryBox = document.getElementById("queryTextbox");
	msdAddTerm(QueryBox.value);
	var SearchTerm = url+parm_cmd+parm_db+parm_term;
	doBiobarURL(SearchTerm);
}

function doClean() {
	document.getElementById('queryTextbox').value = "";
	document.getElementById('queryPDB').value = "";
}

function goMenuAbout() {
	window.openDialog("chrome://biobar/content/about.xul","showmore","chrome");
}

function goMenuHelp() {
	window.openDialog("chrome://biobar/content/biobar-help.xul","showmore","chrome");
}

function DoEnabling() {
	var QueryBox = document.getElementById("queryTextbox").value;

	var QueryButton = document.getElementById("queryButton");
	var QueryExpression = document.getElementById("queryTextbox");
	QueryButton.disabled = !queryTextbox.value;
}

function msdAddTerm(query) {
	var myMenuItem = document.createElement("menuitem");
	myMenuItem.setAttribute("label", query);
	var queryBox = document.getElementById("queryTextbox");
	queryBox.childNodes.item(0).appendChild(myMenuItem);
}

function doPDB() {
	var jjj = document.getElementById('server1').value;
	if (jjj == "MSD") {
		var url = "http://www.ebi.ac.uk/msd-srv/atlas?toolbar=biobar&";
		var parm_cmd = "id";
		var parm_term = "=";
		var parm_db = "";
		var	search = document.getElementById('queryPDB').value;

	} else if (jjj == "OCA") {

		var url = getserverOCA()+"?";
		var parm_cmd = "toolbar=biobar&id";
		var parm_term = "=";
		var parm_db = "";
		var	search = document.getElementById('queryPDB').value;
	} else if (jjj == "RCSB") {
		var url = getserverRCSB()+"cgi/explore.cgi?toolbar=biobar&";
		//       var url = "http://www.rcsb.org/pdb/cgi/explore.cgi?toolbar=biobar&";
		var parm_cmd = "pdbId";
		var parm_term = "=";
		var	search = document.getElementById('queryPDB').value;
	} else if (jjj=="PDBJ") {
		var url ="http://pdb.protein.osaka-u.ac.jp/pdb/cgi/explore.cgi?toolbar=biobar&";
		var parm_cmd = "pdbId";
		var parm_term = "=";
		var search = document.getElementById('queryPDB').value;
	} else if (jjj == "PDBsum") {
		var url ="http://www.ebi.ac.uk/thornton-srv/databases/cgi-bin/pdbsum/GetPage.pl?toolbar=biobar&";
		var parm_cmd = "pdbcode";
		var parm_term = "=";
		var search = document.getElementById('queryPDB').value;

	} else {
		var url = "http://www.ebi.ac.uk/msd-srv/atlas?toolbar=biobar&";
		var parm_cmd = "id";
		var parm_term = "=";
		var parm_db = "";
		var	search = document.getElementById('queryPDB').value;
	}
	var SearchTerm = url+parm_cmd+parm_term+search;
	doBiobarURL(SearchTerm);
}

function doCMD(el) {
	var v = el.getAttribute("value");
	if (v == "") {
		alert('No database chosen');
	} else
		//    alert('new mechanism says ' + v);
		document.getElementById('server1').value=v;
	biobar_SearchMenu();
}

// The Following Functions are adopted from the Webdeveloper Project
// http://www.chrispederick.com/work/firefox/webdeveloper/
// The use of the webdeveloper Code is duly acknowledged.

function triggerURL() {
	var nsIProps = Components.classes["@mozilla.org/file/directory_service;1"].createInstance(Components.interfaces.nsIProperties);
	var userprofile = nsIProps.get("ProfD",Components.interfaces.nsIFile);
	userprofile.append("extensions");
	userprofile.append("{fbfbf0bf-032e-427e-932d-0b000a34f168}");
	if (userprofile.exists()) {
		alert('bioFOX is already installed on your browser \n You can access it from the right mouse button \n with selected text or by using Shift-F10');
	} else {
		InstallTrigger.startSoftwareUpdate('http://downloads.mozdev.org/biofox/biofox.xpi');
	}
}

function biobar_makeLinks(menu, separatorName) {
	const biobarprefs = get_biobarPrefService();
	const validatorSeparator = menu.getElementsByAttribute("id", separatorName)[0];
	var toolsCount            = 0;
	var description           = null;
	var descriptionPreference = null;
	var menuItem              = document.createElement("menuitem");
	var url                   = null;
	var urlValue              = null;
	// If the tools count preference is set
	if(biobarprefs.prefHasUserValue("tool.count"))
	{
		toolsCount = biobarprefs.getIntPref("tool.count");
	}

	biobar_removeGeneratedMenuItems(menu);

	for(var i = 1; i <= toolsCount; i++)
	{
		description = "tool." + i + ".description";
		url         = "tool." + i + ".url";

		// If the description and URL are set
		if(biobarprefs.prefHasUserValue(description) && biobarprefs.prefHasUserValue(url))
		{
			descriptionPreference = biobarprefs.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
			urlValue = biobarprefs.getComplexValue(url,Components.interfaces.nsISupportsString).data.trim();

			// If the description is not blank
			if(descriptionPreference != "")
			{
				menuItem = document.createElement("menuitem");
				menuItem.setAttribute("label", descriptionPreference);
				menuItem.setAttribute("class","biobar-custom-menu");
				menuItem.setAttribute("oncommand","window._content.location.href='" + urlValue + "'");
				menu.insertBefore(menuItem,validatorSeparator);
			}
		}
	}
}

function biobar_removeGeneratedMenuItems(menu)
{
	var menuItem  = null;
	var menuItems = menu.getElementsByAttribute("class", "biobar-custom-menu");

	// Loop through the menu items
	for(var i = 0; i < menuItems.length; i++)
	{
		menu.removeChild(menuItems[i]);
	}

	menuItems = menu.getElementsByAttribute("class", "biobar-custom-menu");

	// Loop through the menu items again because of the change to the behavior of getElementsByAttribute
	while(menuItems.length > 0)
	{
		menu.removeChild(menuItems[0]);
	}
}


// Tests if a string ends with the given string
String.prototype.endsWith = function(endsWithString)
                            {
	                            return (this.substr(this.length - endsWithString.length) == endsWithString);
                            }

                            // Trims leading and trailing spaces from a string
                            String.prototype.trim = function()
                                                    {
	                                                    return this.replace(new RegExp("^\\s+|\\s+$", "gi"), "");
                                                    }

                                                    function biobar_removeAllChildNodes(node)
                                                    {
	                                                    var childNodes = node.childNodes;

	                                                    // Loop through the child nodes
	                                                    for(var i = 0; i < childNodes.length; i++)
	                                                    {
		                                                    node.removeChild(childNodes[i]);
	                                                    }

	                                                    childNodes = node.childNodes;

	                                                    // Loop through the child nodes
	                                                    while(childNodes.length > 0)
	                                                    {
		                                                    node.removeChild(childNodes[0]);
	                                                    }
                                                    }
